<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="xml" omit-xml-declaration="yes"/>
<xsl:strip-space elements="*"/>
<xsl:preserve-space elements="xsl:text"/>
<xsl:variable name="newline">
<xsl:text>&#10;</xsl:text>
</xsl:variable>
<xsl:variable name="template_elts">
<xsl:text>xsl:attribute|xsl:apply-templates|xsl:apply-imports|xsl:call-template|xsl:comment|xsl:copy|xsl:copy-of|xsl:element|xsl:fallback|xsl:message|xsl:number|xsl:processing-instruction|xsl:value-of|xsl:text|xsl:param|xsl:variable|xsl:choose|xsl:for-each|xsl:if</xsl:text>
</xsl:variable>
<xsl:template match="/">
<xsl:apply-templates select="xsl:stylesheet"/>
</xsl:template>
<xsl:template match="xsl:stylesheet">
<xsl:text>stylesheet [</xsl:text>
<xsl:for-each select="@*">
<xsl:value-of select="name()"/>
<xsl:text>=&quot;</xsl:text>
<xsl:value-of select="."/>
<xsl:text>&quot;</xsl:text>
</xsl:for-each>
<xsl:text>];</xsl:text>
<xsl:value-of select="$newline"/>
<xsl:for-each select="*">
<xsl:apply-templates select="."/>
<xsl:text>;</xsl:text>
<xsl:value-of select="$newline"/>
<xsl:value-of select="$newline"/>
</xsl:for-each>
</xsl:template>

<xsl:template match="xsl:output">
<xsl:text>output [</xsl:text>
<xsl:for-each select="@*">
<xsl:value-of select="name()"/>
<xsl:text>=&quot;</xsl:text>
<xsl:value-of select="."/>
<xsl:text>&quot;</xsl:text>
<xsl:if test="position() != last()">
<xsl:text>,</xsl:text>
</xsl:if>
</xsl:for-each>
<xsl:text>]</xsl:text>
</xsl:template>
<xsl:template match="xsl:decimal-format">
<xsl:text>decimal-format [</xsl:text>
<xsl:for-each select="@*">
<xsl:value-of select="name()"/>
<xsl:text>=&quot;</xsl:text>
<xsl:value-of select="."/>
<xsl:text>&quot;</xsl:text>
<xsl:if test="position() != last()">
<xsl:text>,</xsl:text>
</xsl:if>
</xsl:for-each>
<xsl:text>]</xsl:text>
</xsl:template>
<xsl:template match="xsl:include">
<xsl:text>include &quot;</xsl:text>
<xsl:value-of select="@href"/>
<xsl:text>&quot;</xsl:text>
</xsl:template>
<xsl:template match="xsl:import">
<xsl:text>import &quot;</xsl:text>
<xsl:value-of select="@href"/>
<xsl:text>&quot;</xsl:text>
</xsl:template>
<xsl:template match="xsl:preserve-space">
<xsl:text>preserve-space &quot;</xsl:text>
<xsl:value-of select="@elements"/>
<xsl:text>&quot;</xsl:text>
</xsl:template>
<xsl:template match="xsl:strip-space">
<xsl:text>strip-space &quot;</xsl:text>
<xsl:value-of select="@elements"/>
<xsl:text>&quot;</xsl:text>
</xsl:template>
<xsl:template match="xsl:variable">
<xsl:text>let </xsl:text>
<xsl:value-of select="@name"/>
<xsl:text> = </xsl:text>
<xsl:choose>
<xsl:when test="boolean(child::*)">
<xsl:text>{</xsl:text>
<xsl:apply-templates select="child::*"/>
<xsl:text>}</xsl:text>
</xsl:when>
<xsl:when test="boolean(@select)">
<xsl:text>&quot;</xsl:text>
<xsl:value-of select="@select"/>
<xsl:text>&quot;</xsl:text>
</xsl:when>
</xsl:choose>
</xsl:template>
<xsl:template match="xsl:with-param">
<xsl:text>with-param </xsl:text>
<xsl:value-of select="@name"/>
<xsl:text> = </xsl:text>
<xsl:choose>
<xsl:when test="boolean(child::*)">
<xsl:text>{</xsl:text>
<xsl:apply-templates select="child::*"/>
<xsl:text>}</xsl:text>
</xsl:when>
<xsl:when test="boolean(@select)">
<xsl:text>&quot;</xsl:text>
<xsl:value-of select="@select"/>
<xsl:text>&quot;</xsl:text>
</xsl:when>
</xsl:choose>
</xsl:template>
<xsl:template match="xsl:template">
<xsl:if test="boolean(@name)">
<xsl:value-of select="@name"/>
<xsl:text> </xsl:text>
</xsl:if>
<xsl:if test="boolean(@match)">
<xsl:text>&quot;</xsl:text>
<xsl:value-of select="@match"/>
<xsl:text>&quot; </xsl:text>
</xsl:if>
<xsl:if test="boolean(@priority)">
<xsl:text>priority </xsl:text>
<xsl:value-of select="@match"/>
<xsl:text> </xsl:text>
</xsl:if>
<xsl:if test="boolean(@mode)">
<xsl:text>mode </xsl:text>
<xsl:value-of select="@match"/>
<xsl:text> </xsl:text>
</xsl:if>
<xsl:text disable-output-escaping="yes">-&gt; {</xsl:text>
<xsl:value-of select="$newline"/>
<xsl:for-each select="*">
<xsl:apply-templates select="."/>
<xsl:if test="position() != last()">
<xsl:text>,</xsl:text>
</xsl:if>
<xsl:value-of select="$newline"/>
</xsl:for-each>
<xsl:text>}</xsl:text>
</xsl:template>
<xsl:template match="xsl:apply-templates">
<xsl:text>apply-templates</xsl:text>
<xsl:if test="boolean(@select)">
<xsl:text> to </xsl:text>
<xsl:text>&quot;</xsl:text>
<xsl:value-of select="@select"/>
<xsl:text>&quot;</xsl:text>
</xsl:if>
</xsl:template>
<xsl:template match="xsl:call-template">
<xsl:text>call-template </xsl:text>
<xsl:text>&quot;</xsl:text>
<xsl:value-of select="@name"/>
<xsl:text>&quot;</xsl:text>
<xsl:if test="boolean(child::*)">
<xsl:text> { </xsl:text>
<xsl:apply-templates select="*"/>
<xsl:text> } </xsl:text>
</xsl:if>
</xsl:template>
<xsl:template match="xsl:choose">
<xsl:text>choose {</xsl:text>
<xsl:value-of select="$newline"/>
<xsl:for-each select="*">
<xsl:apply-templates select="."/>
<xsl:if test="position() != last()">
<xsl:text>;</xsl:text>
</xsl:if>
<xsl:value-of select="$newline"/>
</xsl:for-each>
</xsl:template>
<xsl:template match="xsl:for-each">
<xsl:text>for-each </xsl:text>
<xsl:text>&quot;</xsl:text>
<xsl:value-of select="@select"/>
<xsl:text>&quot; {</xsl:text>

<xsl:value-of select="$newline"/>
<xsl:for-each select="xsl:sort">
<xsl:apply-templates select="."/>
<xsl:if test="position() != last()">
<xsl:text>,</xsl:text>
</xsl:if>
<xsl:value-of select="$newline"/>
</xsl:for-each>
<xsl:for-each select="*">
<xsl:if test="not(boolean(xsl:sort))">
<xsl:apply-templates select="."/>
<xsl:if test="position() != last()">
<xsl:text>,</xsl:text>
</xsl:if>
<xsl:value-of select="$newline"/>
</xsl:if>
</xsl:for-each>

<xsl:text>}</xsl:text>
</xsl:template>
<xsl:template match="xsl:if">
<xsl:text>if </xsl:text>
<xsl:text>&quot;</xsl:text>
<xsl:value-of select="@test"/>
<xsl:text>&quot; {</xsl:text>
<xsl:value-of select="$newline"/>
<xsl:for-each select="*">
<xsl:apply-templates select="."/>
<xsl:if test="position() != last()">
<xsl:text>,</xsl:text>
</xsl:if>
<xsl:value-of select="$newline"/>
</xsl:for-each>
<xsl:text>}</xsl:text>
</xsl:template>
<xsl:template match="xsl:attribute">
<xsl:text>@</xsl:text>
<xsl:if test="boolean(@namespace)">
<xsl:value-of select="@namespace"/>
<xsl:text>:</xsl:text>
</xsl:if>
<xsl:value-of select="@name"/>
<xsl:text> {</xsl:text>
<xsl:for-each select="*">
<xsl:apply-templates select="."/>
<xsl:if test="position() != last()">
<xsl:text>,</xsl:text>
<xsl:value-of select="$newline"/>
</xsl:if>
</xsl:for-each>
<xsl:text>}</xsl:text>
</xsl:template>
<xsl:template match="xsl:comment">
<xsl:text>comment</xsl:text>
<xsl:text> {</xsl:text>
<xsl:for-each select="*">
<xsl:apply-templates select="."/>
<xsl:if test="position() != last()">
<xsl:text>,</xsl:text>
</xsl:if>
<xsl:value-of select="$newline"/>
</xsl:for-each>
<xsl:text>}</xsl:text>
</xsl:template>
<xsl:template match="xsl:copy">
<xsl:text>copy</xsl:text>
<xsl:text> {</xsl:text>
<xsl:for-each select="*">
<xsl:apply-templates select="."/>
<xsl:if test="position() != last()">
<xsl:text>,</xsl:text>
</xsl:if>
<xsl:value-of select="$newline"/>
</xsl:for-each>
<xsl:text>}</xsl:text>
</xsl:template>
<xsl:template match="xsl:copy-of">
<xsl:text>copy-of </xsl:text>
<xsl:text>&quot;</xsl:text>
<xsl:value-of select="@select"/>
<xsl:text>&quot;</xsl:text>
</xsl:template>
<xsl:template match="xsl:element">
<xsl:text disable-output-escaping="yes">&lt;</xsl:text>
<xsl:if test="boolean(@namespace)">
<xsl:value-of select="@namespace"/>
<xsl:text>:</xsl:text>
</xsl:if>
<xsl:value-of select="@name"/>
<xsl:text disable-output-escaping="yes">&gt; {</xsl:text>
<xsl:value-of select="$newline"/>
<xsl:for-each select="*">
<xsl:apply-templates select="."/>
<xsl:if test="position() != last()">
<xsl:text>,</xsl:text>
</xsl:if>
<xsl:value-of select="$newline"/>
</xsl:for-each>
<xsl:text>}</xsl:text>
</xsl:template>
<xsl:template match="xsl:text">
<xsl:text>&quot;</xsl:text>
<xsl:value-of select="."/>
<xsl:text>&quot;</xsl:text>
</xsl:template>
<xsl:template match="xsl:value-of">
<xsl:text>value-of </xsl:text>
<xsl:text>&quot;</xsl:text>
<xsl:value-of select="@select"/>
<xsl:text>&quot;</xsl:text>
</xsl:template>
<xsl:template match="xsl:sort">
<xsl:text>sort [</xsl:text>
<xsl:for-each select="@*">
<xsl:value-of select="name()"/>
<xsl:text>=&quot;</xsl:text>
<xsl:value-of select="."/>
<xsl:text>&quot;</xsl:text>
<xsl:if test="position() != last()">
<xsl:text>,</xsl:text>
</xsl:if>
</xsl:for-each>
<xsl:text>]</xsl:text>
</xsl:template>
<xsl:template match="text()">
<xsl:text>&quot;</xsl:text>
<xsl:value-of select="."/>
<xsl:text>&quot;</xsl:text>
</xsl:template>
<xsl:template match="*">
<xsl:text disable-output-escaping="yes">&lt;</xsl:text>
<xsl:if test="boolean(@namespace)">
<xsl:value-of select="@namespace"/>
<xsl:text>:</xsl:text>
</xsl:if>
<xsl:value-of select="name()"/>
<xsl:for-each select="@*">
<xsl:text> </xsl:text>
<xsl:value-of select="name()"/>
<xsl:text>=&quot;</xsl:text>
<xsl:value-of select="."/>
<xsl:text>&quot;</xsl:text>
</xsl:for-each>
<xsl:text disable-output-escaping="yes">&gt; {</xsl:text>
<xsl:value-of select="$newline"/>
<xsl:for-each select="*|text()">
<xsl:apply-templates select="."/>
<xsl:if test="position() != last()">
<xsl:text>,</xsl:text>
</xsl:if>
<xsl:value-of select="$newline"/>
</xsl:for-each>
<xsl:text>}</xsl:text>
</xsl:template>
</xsl:stylesheet>