stylesheet [version="1.0"];
output [method="text"];

strip-space "*";

let newline = {"
"};

"/" -> {
apply-templates to "xyacc"
};

"xyacc" -> {
apply-templates to "declarations",
value-of "$newline",
"%%",
value-of "$newline",
apply-templates to "rules",
value-of "$newline"
};

"declarations" -> {
apply-templates to "token_declaration|associativity_declaration|type_declaration|start_declaration|symtbl_declaration"
};

"token_declaration" -> {
"%token",
apply-templates to "type",
for-each "token_id" {
" ",
value-of "."
},
value-of "$newline"
};

"associativity_declaration" -> {
"%",
value-of "@direction",
for-each "token_id" {
" ",
value-of "."
},
value-of "$newline"
};

"type_declaration" -> {
"%type",
apply-templates to "type",
for-each "nonterm_id" {
" ",
value-of "."
},
value-of "$newline"
};

"start_declaration" -> {
"%start ",
value-of "nonterm_id",
value-of "$newline"
};

"symtbl_declaration" -> {
"%symtbl",
for-each "symtbl_id" {
" ",
value-of "."
},
value-of "$newline"
};

"type" -> {
" &lt;",
apply-templates to "stringty|elementty|attributety|contentty|listty",
"&gt;"
};

"stringty" -> {
"string"
};

"elementty" -> {
"element"
};

"attributety" -> {
"attribute"
};

"contentty" -> {
"content"
};

"listty" -> {
"list ",
apply-templates to "*[1]"
};

"rules" -> {
apply-templates to "rule"
};

"rule" -> {
value-of "nonterm_id",
" : ",
for-each "match" {
apply-templates to ".",
if "position() != last()" {
value-of "$newline",
" | "
}
},
value-of "$newline",
";",
value-of "$newline"
};

"error_match" -> {
"error"
};

"symbol" -> {
apply-templates to "token_id|nonterm_id|char",
" "
};

"token_id" -> {
value-of "."
};

"nonterm_id" -> {
value-of "."
};

"char" -> {
"'",
value-of ".",
"'"
};

"precedence" -> {
"%prec ",
value-of "token_id"
};

"seq" -> {
"{",
apply-templates,
"}"
};

"action" -> {
apply-templates
};

"term" -> {
apply-templates
};

"empty" -> {
"&quot;&quot;"
};

"concat" -> {
"concat(",
apply-templates to "*[1]",
",",
apply-templates to "*[2]",
")"
};

"string" -> {
"&quot;",
value-of ".",
"&quot;"
};

"text" -> {
"text(",
apply-templates to "*[1]",
")"
};

"text" -> {
"literal(",
apply-templates to "*[1]",
")"
};

"element" -> {
"element(",
apply-templates to "name",
",",
apply-templates to "attlist",
",",
apply-templates to "content",
")"
};

"attribute" -> {
"att[",
apply-templates to "name",
"](",
value-of "value",
")"
};

"nil" -> {
"nil"
};

"cons" -> {
"cons(",
apply-templates to "*[1]",
",",
apply-templates to "*[2]",
")"
};

"append" -> {
"append(",
apply-templates to "*[1]",
",",
apply-templates to "*[2]",
")"
};

"list" -> {
"list(",
for-each "./*" {
apply-templates to ".",
if "position() != last()" {
", "
}
},
")"
};

"rev" -> {
"rev(",
apply-templates to "*[1]",
")"
};

"error" -> {
"error(",
apply-templates to "*[1]",
")"
};

"accept" -> {
"accept(",
apply-templates to "*[1]",
")"
};

"var" -> {
"$",
value-of "@num"
};

"add" -> {
"ADD(",
value-of ".",
",",
apply-templates to "term",
");"
};

"remove" -> {
"REMOVE(",
value-of ".",
",",
apply-templates to "term",
");"
};

