stylesheet [version="1.0"];
output [method="xml",indent="yes"];

strip-space "*";

let newline = {"
"};

"/" -> {
<yacc> {
apply-templates to "xyacc"
}
};

"xyacc" -> {
<declarations> {
<token_declaration> {
<token_id> {
"NONE"
}
},
<code_declaration> {
<ccode> {
"
#include &quot;xmlbase.h&quot;
"
}
},
<union_declaration> {
<union_field> {
<type> {
"xml_list_t*"
},
"foo",
<type_id> {
"xml_list"
}
},
<union_field> {
<type> {
"xml_element_t*"
},
<type_id> {
"xml_element"
}
},
<union_field> {
<type> {
"xml_attribute_t*"
},
<type_id> {
"xml_attribute"
}
},
<union_field> {
<type> {
"xml_content_t*"
},
<type_id> {
"xml_content"
}
},
<union_field> {
<type> {
"char*"
},
<type_id> {
"xml_string"
}
}
},
call-template "symtbl_definitions",
apply-templates to "declarations"
},
<rules> {
apply-templates to "rules"
},
<definitions> {
}
};

symtbl_definitions -> {
<code_declaration> {
for-each "/xyacc/declarations/symtbl_declaration/symtbl_id" {
"extern symtbl_t ",
apply-templates to ".",
";",
value-of "$newline"
}
}
};

"declarations" -> {
apply-templates to "token_declaration|associativity_declaration|type_declaration|start_declaration"
};

"symtbl_declaration" -> {
};

"token_declaration" -> {
<token_declaration> {
for-each "type" {
<type_id> {
apply-templates to "."
}
},
for-each "token_id" {
apply-templates to "."
}
}
};

"associativity_declaration" -> {
<associativity_declaration> {
copy-of "./@direction",
for-each "token_id" {
apply-templates to "."
}
}
};

"type_declaration" -> {
<type_declaration> {
<type_id> {
apply-templates to "type"
},
for-each "nonterm_id" {
copy-of "."
}
}
};

"start_declaration" -> {
copy-of "."
};

"type" -> {
apply-templates to "stringty|elementty|contentty|attributety|listty"
};

"stringty" -> {
"xml_string"
};

"elementty" -> {
"xml_element"
};

"attributety" -> {
"xml_attribute"
};

"contentty" -> {
"xml_content"
};

"listty" -> {
"xml_list"
};

"rules" -> {
apply-templates to "rule"
};

"rule" -> {
<rule> {
copy-of "nonterm_id",
for-each "match" {
<match> {
apply-templates to "."
}
}
}
};

"error_match" -> {
<error_match> {
}
};

"symbol" -> {
<symbol> {
apply-templates to "token_id|nonterm_id|char"
}
};

"token_id" -> {
<token_id> {
"TOK_",
value-of "."
}
};

"symtbl_id" -> {
<symtbl_id> {
"SYMTBL_",
value-of "."
}
};

"nonterm_id" -> {
copy-of "."
};

"char" -> {
copy-of "."
};

"precedence" -> {
copy-of "."
};

"seq" -> {
<action> {
<ccode> {
for-each "*" {
apply-templates to "."
}
}
}
};

"action" -> {
for-each "term" {
"$$ = ",
apply-templates to ".",
";"
},
for-each "error" {
"ERROR(",
apply-templates to "*[1]",
");"
},
for-each "accept" {
"$$ = ",
apply-templates to ".",
";",
value-of "$newline",
"fprint_xml_content(stdout,$$);",
value-of "$newline",
"YYACCEPT;"
}
};

"empty" -> {
"&quot;&quot;"
};

"concat" -> {
"CONCAT(",
apply-templates to "*[1]",
",",
apply-templates to "*[2]",
")"
};

"string" -> {
"&quot;",
value-of ".",
"&quot;"
};

"literal" -> {
"LITERAL(",
apply-templates to "*[1]",
")"
};

"text" -> {
"TEXT(",
apply-templates to "*[1]",
")"
};

"element" -> {
"ELEMENTATTS(",
apply-templates to "name",
",",
apply-templates to "attlist",
",",
apply-templates to "content",
")"
};

"attribute" -> {
"ATTRIBUTE(",
apply-templates to "name",
",",
apply-templates to "value",
")"
};

"nil" -> {
"NIL"
};

"cons" -> {
"CONS(",
apply-templates to "*[1]",
",",
apply-templates to "*[2]",
")"
};

"append" -> {
"APPEND(",
apply-templates to "*[1]",
",",
apply-templates to "*[2]",
")"
};

"list" -> {
"LIST(",
for-each "./*" {
apply-templates to ".",
if "position() != last()" {
", "
}
},
",NIL)"
};

"rev" -> {
"REV(",
apply-templates to "*[1]",
")"
};

"var" -> {
"$",
value-of "@num"
};

"add" -> {
"ADD(",
apply-templates to "symtbl_id",
",",
apply-templates to "term",
");"
};

"remove" -> {
"REMOVE(",
apply-templates to "symtbl_id",
",",
apply-templates to "term",
");"
};

