stylesheet [version="1.0"];
output [method="text"];

strip-space "*";

let newline = {"
"};

"/" -> {
apply-templates to "yacc"
};

"yacc" -> {
apply-templates to "declarations",
value-of "$newline",
"%%",
value-of "$newline",
apply-templates to "rules",
value-of "$newline",
"%%",
value-of "$newline",
apply-templates to "definitions",
value-of "$newline"
};

"declarations" -> {
apply-templates to "token_declaration|union_declaration|associativity_declaration|type_declaration|start_declaration|code_declaration"
};

"token_declaration" -> {
"%token ",
apply-templates to "type_id",
for-each "token_id" {
" ",
value-of "."
},
value-of "$newline"
};

"union_declaration" -> {
"%union {",
value-of "$newline",
for-each "union_field" {
value-of "type",
" ",
value-of "type_id",
";",
value-of "$newline"
},
"};",
value-of "$newline"
};

"associativity_declaration" -> {
"%",
value-of "@direction",
for-each "token_id" {
" ",
value-of "."
},
value-of "$newline"
};

"type_declaration" -> {
"%type ",
apply-templates to "type_id",
for-each "nonterm_id" {
" ",
value-of "."
},
value-of "$newline"
};

"type_id" -> {
"&lt;",
value-of ".",
"&gt; "
};

"start_declaration" -> {
"%start ",
value-of "nonterm_id",
value-of "$newline"
};

"code_declaration" -> {
"%{",
value-of "$newline",
value-of ".",
value-of "$newline",
"%}",
value-of "$newline"
};

"rules" -> {
apply-templates to "rule"
};

"rule" -> {
value-of "nonterm_id",
" : ",
for-each "match" {
apply-templates to ".",
if "position() != last()" {
value-of "$newline",
" | "
}
},
value-of "$newline",
";",
value-of "$newline"
};

"match" -> {
for-each "error_match|symbol|action" {
apply-templates to ".",
if "position() != last()" {
" "
}
}
};

"error_match" -> {
"error"
};

"symbol" -> {
apply-templates to "token_id|nonterm_id|char"
};

"token_id" -> {
value-of "."
};

"nonterm_id" -> {
value-of "."
};

"char" -> {
"'",
value-of ".",
"'"
};

"precedence" -> {
"%prec ",
value-of "token_id"
};

"action" -> {
"{",
apply-templates to "ccode",
"}"
};

"ccode" -> {
value-of "."
};

